#include <avr/io.h>
#include <avr/interrupt.h>
#include "types.h"
#include "spi.h"

u08 len, dbyte, *rxptr, *txptr;
void (*SPIevent)();


unsigned char SPI_transfer_IRQ(u08 n,u08 b,u08* txp,u08* rxp,void* event)
{ 
 if(len) return 0;
 if(txp) b = *txp++;
 SPDR = b;
 dbyte = b;
 len = n;
 txptr = txp;
 rxptr = rxp;
 SPIevent = event;
 return 1;
}

ISR (SPI_STC_vect)
{
 if(!len) return;
 if(txptr) dbyte = *txptr++;
 if(rxptr) *rxptr++ = SPDR;
 if(--len)
 {
     SPDR = dbyte;
     return;
 }
 if(SPIevent) (*SPIevent)();
}





