#ifndef __types_h__
#define __types_h__


#define __device_reset()  	asm volatile("jmp 0")

#define MAX_U16  65535
#define MAX_S16  32767

//#define const static __attribute__ ((section (".noinit")))

#ifdef __ATTR_CONST__
#undef  __ATTR_CONST__
#endif
#define __ATTR_CONST__ __attribute__ ((section (".const")))

#define const static __ATTR_CONST__


#if defined(__DOXYGEN__)
/*
 * The #define below is just a dummy that serves documentation
 * purposes only.
 */
/** \ingroup avr_pgmspace
    \def PSTR(s)

    Used to declare a static pointer to a string in program space. */
#define CONST(s) ((const char *)(s))
#else  /* !DOXYGEN */
/* The real thing. */
#define CONST(s) (__extension__({ const char __c[] = (s); &__c[0];}))
#endif /* DOXYGEN */





#define NULL	0
#define null	NULL

#define enable()	 asm("sei")
#define disable()	 asm("cli")


#define xtal 11059200


typedef unsigned char  BYTE;
typedef unsigned int   WORD;
typedef unsigned long  DWORD;

typedef unsigned short  USHORT;
typedef unsigned char   BOOL;

typedef unsigned char  UCHAR;
typedef unsigned int   UINT;
typedef unsigned long  ULONG;

typedef char  CHAR;
typedef int   INT;
typedef long  LONG;

// alternative types

typedef unsigned char  u08;
typedef unsigned short u16;
typedef unsigned long  u32;

typedef signed char  s08;
typedef signed short s16;
typedef signed long  s32;

#define byte BYTE

#endif




